download/panel/frp/update.sh
2024-11-10 02:06:42 +08:00

91 lines
2.5 KiB (Stored with Git LFS)
Bash

#!/bin/bash
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:$PATH
: '
Copyright (C) 2022 - now HaoZi Technology Co., Ltd.
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.
You should have received a copy of the GNU Affero General Public License
along with this program. If not, see <https://www.gnu.org/licenses/>.
'
source <(curl -f -s --connect-timeout 10 --retry 3 https://dl.cdn.haozi.net/panel/public.sh)
if [ $? -ne 0 ]; then
echo "下载 public.sh 失败,请检查网络或稍后重试。"
echo "Download public.sh failed, please check the network or try again later."
exit 1
fi
channel=${1}
version=${2}
frp_path="${setup_path}/server/frp"
if [ ! -d "${frp_path}" ]; then
mkdir -p ${frp_path}
fi
# 架构判断
if [ ${ARCH} == "x86_64" ]; then
frpFile="frp_${version}_linux_amd64.7z"
elif [ ${ARCH} == "aarch64" ]; then
frpFile="frp_${version}_linux_arm64.7z"
else
error "不支持的架构"
fi
# 备份配置
if [ -f "${frp_path}/frps.toml" ]; then
cp -f ${frp_path}/frps.toml ${frp_path}/frps.toml.bak
fi
if [ -f "${frp_path}/frpc.toml" ]; then
cp -f ${frp_path}/frpc.toml ${frp_path}/frpc.toml.bak
fi
# 下载frp
cd ${frp_path}
wget -T 120 -t 3 -O ${frp_path}/${frpFile} ${download_url}/frp/${frpFile}
wget -T 20 -t 3 -O ${frp_path}/${frpFile}.sha256 ${download_url}/frp/${frpFile}.sha256
if ! sha256sum --status -c ${frp_path}/${frpFile}.sha256; then
rm -rf ${frp_path}
error "frp 校验失败"
fi
# 解压frp
cd ${frp_path}
7z x ${frpFile}
chown -R www:www ${frp_path}
chmod -R 700 ${frp_path}
rm -f ${frpFile} ${frpFile}.sha256
# 还原配置
if [ -f "${frp_path}/frps.toml.bak" ]; then
cp -f ${frp_path}/frps.toml.bak ${frp_path}/frps.toml
fi
if [ -f "${frp_path}/frpc.toml.bak" ]; then
cp -f ${frp_path}/frpc.toml.bak ${frp_path}/frpc.toml
fi
systemctl restart frps
if [ "$?" != "0" ]; then
error "启动失败"
fi
systemctl restart frpc
if [ "$?" != "0" ]; then
error "启动失败"
fi
panel-cli app write frp ${channel} ${version}
echo -e ${HR}
echo "升级完成"
echo -e ${HR}